-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.0.38-Ubuntu_0ubuntu1.4-log


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema ptk
--

CREATE DATABASE IF NOT EXISTS ptk;
USE ptk;

--
-- Definition of table `ptk`.`cases`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`cases` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `description` longtext NOT NULL,
  `creation_time` datetime NOT NULL,
  `closing_time` datetime NOT NULL,
  `is_locked` smallint(6) NOT NULL,
  PRIMARY KEY  (`id`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;

--
--
-- Definition of table `ptk`.`images`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`images` (
  `id` int(11) NOT NULL auto_increment,
  `id_case` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` longtext NOT NULL,
  `image_path` longtext NOT NULL,
  `image_size` varchar(30) NOT NULL,
  `image_md5` varchar(32) NOT NULL,
  `image_sha1` varchar(40) NOT NULL,
  `image_md5_check` varchar(50) NOT NULL,
  `image_sha1_check` varchar(50) NOT NULL,
  `acquisition_type` tinyint(4) NOT NULL,
  `acquisition_time` datetime NOT NULL,
  `acquisition_operator` varchar(100) NOT NULL,
  `acquisition_location` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`,`id_case`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;

--
-- Definition of table `ptk`.`partition_files`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`partition_files` (
  `id` int(11) NOT NULL auto_increment,
  `id_partition` int(11) NOT NULL,
  `file_name` varchar(255) NOT NULL,
  `is_directory` tinyint(4) NOT NULL,
  `is_deleted` tinyint(4) NOT NULL,
  `inode` varchar(10) NOT NULL,
  `keywords` longtext NOT NULL,
  `file_type` varchar(255) NOT NULL,
  `md5` varchar(32) NOT NULL,
  `sha1` varchar(40) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Definition of table `ptk`.`partitions`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`partitions` (
  `id` int(11) NOT NULL auto_increment,
  `id_image` int(11) NOT NULL,
  `filesystem` varchar(50) NOT NULL,
  `performed_operations` varchar(255) NOT NULL,
  `size` varchar(30) NOT NULL,
  `offset` int(11) NOT NULL,
  `is_partition` tinyint(4) NOT NULL,
  `timezone` varchar( 50 ) NOT NULL,
  PRIMARY KEY  (`id`,`id_image`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;

--
-- Definition of table `ptk`.`timeline_files`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`timeline_files` (
  `id` int(11) NOT NULL auto_increment,
  `id_file` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `action` varchar(4) NOT NULL,
  `size` int(11) NOT NULL,
  `permission` varchar(15) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Definition of table `ptk`.`users`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`users` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `surname` varchar(100) NOT NULL,
  `mail1` varchar(100) NOT NULL,
  `mail2` varchar(100) NOT NULL,
  `phone1` varchar(100) NOT NULL,
  `phone2` varchar(100) NOT NULL,
  `username` varchar(100) NOT NULL,
  `password` varchar(40) NOT NULL,
  `is_locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`,`username`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;

--
-- Definition of table `ptk`.`users_cases`
--

CREATE TABLE IF NOT EXISTS  `ptk`.`users_cases` (
  `id_user` int(11) NOT NULL,
  `id_case` int(11) NOT NULL,
  `datetime` datetime NOT NULL,
  `is_locked` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id_user`,`id_case`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `ptk`.`bookmarks` (
  `id` int(11) NOT NULL auto_increment,
  `id_case` int(11) NOT NULL,
  `id_partition` int(11) NOT NULL,
  `user` text NOT NULL,
  `title` longtext NOT NULL,
  `description` longtext NOT NULL,
  `tags` longtext NOT NULL,
  `type` int(11) NOT NULL,
  `reference` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
